using Microsoft.AspNetCore.Builder;
using MongoDB.Driver;
using Todo.Persistence.Mongo.Repositories.Dtos;

namespace Todo.Persistence.Mongo
{
    public static class Migrations
    {
        public static IApplicationBuilder MigrateMongoDb(this IApplicationBuilder app)
        {
            Task.Run(async () =>
            {
                var conn = new MongoClient("mongodb://root:example@localhost:27017");
                var database = conn.GetDatabase("todo");

                await CreateIndexes(database);
            }).Wait(10000);

            return app;
        }

        private static async Task CreateIndexes(IMongoDatabase mongoDatabase)
        {
            Console.WriteLine("Running: CreateIndexes");
            var collection = mongoDatabase.GetCollection<MongoUser>("users");
            var indexKeysDefinition = Builders<MongoUser>.IndexKeys.Ascending(user => user.Email);
            var indexModel =
                new CreateIndexModel<MongoUser>(indexKeysDefinition, new CreateIndexOptions() { Unique = true });

            await collection.Indexes.CreateOneAsync(indexModel);
            Console.WriteLine("Finished: CreateIndexes");
        }
    }
}