using MongoDB.Driver;
using Todo.Core.Entities;
using Todo.Core.Interfaces.Persistence;
using Todo.Persistence.Mongo.Repositories.Dtos;

namespace Todo.Persistence.Mongo.Repositories
{
    public class UserRepository : IUserRepository
    {
        private readonly IMongoCollection<MongoUser> _usersCollection;

        public UserRepository()
        {
            var conn = new MongoClient("mongodb://root:example@localhost:27017");
            var database = conn.GetDatabase("todo");

            _usersCollection = database.GetCollection<MongoUser>("users");
        }

        public async Task<User> Register(string email, string password)
        {
            var dtoUser = new MongoUser() { Email = email, Password = password };
            await _usersCollection.InsertOneAsync(dtoUser);
            return new User() { Email = dtoUser.Email, Id = dtoUser.Id };
        }
    }
}