import { useState } from "react";
import { CollapsedAddTodo } from "@src/components/todos/collapsed/collapsedAddTodo";
import { AddTodoForm } from "@src/components/todos/collapsed/addTodoForm";
import { CollapsedState } from "@src/components/todos/collapsed/collapsedState";
import {HubConnection} from "@microsoft/signalr";

export function AddTodo(props: {conn: HubConnection}) {
  const [collapsed, setCollapsed] = useState<CollapsedState>(
    CollapsedState.collapsed
  );

  if (collapsed === CollapsedState.collapsed) {
    return (
      <CollapsedAddTodo
        onClick={() => setCollapsed(CollapsedState.notCollapsed)}
      />
    );
  }

  return (
    <AddTodoForm
      onAdd={(todoName) => {
        props.conn.invoke("CreateTodo", todoName).catch(console.error)
      }}
      onClose={() => setCollapsed(CollapsedState.collapsed)}
    />
  );
}
