import { Todo } from "@src/core/entities/todo";
import { TodoItem } from "@src/components/todos/todoItem";
import { AddTodo } from "@src/components/todos/addTodo";
import { HubConnection } from "@microsoft/signalr";

export const TodoList = (props: { todos: Todo[]; conn: HubConnection }) => (
  <>
    <ul id="inbox">
      {props.todos.map((t, i) => (
        <li key={i}>
          <TodoItem
            todo={t}
            updateTodo={(todo) => {
              props.conn
                .invoke("UpdateTodo", todo.id, todo.status)
                .catch(console.error);
            }}
          />
        </li>
      ))}
    </ul>
    <AddTodo conn={props.conn} />
  </>
);
